# Generated by sila2.code_generator; sila2.__version__: 0.10.5
from __future__ import annotations

from datetime import timedelta
from typing import TYPE_CHECKING

from sila2.server import MetadataDict, ObservableCommandInstance

from ..generated.lightintensitycontroller import ControlLightIntensity_Responses, LightIntensityControllerBase

if TYPE_CHECKING:
    from ..server import Server


class LightIntensityControllerImpl(LightIntensityControllerBase):
    def __init__(self, parent_server: Server) -> None:
        super().__init__(parent_server=parent_server)

        # Default lifetime of observable command instances. Possible values:
        # None: Command instance is valid and stored in memory until server shutdown
        # datetime.timedelta: Command instance is deleted after this duration, can be increased during command runtime
        self.ControlLightIntensity_default_lifetime_of_execution = timedelta(minutes=30)

    def ControlLightIntensity(
        self, TargetLightIntensity: float, *, metadata: MetadataDict, instance: ObservableCommandInstance
    ) -> ControlLightIntensity_Responses:
        # set execution status from `waiting` to `running`
        instance.begin_execution()

        raise NotImplementedError  # TODO
